# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Face::V1_0
  module Models
    #
    # Request body for identify face operation.
    #
    class IdentifyRequest

      include MsRestAzure

      # @return Array of query faces faceIds, created by the Face - Detect.
      # Each of the faces are identified independently. The valid number of
      # faceIds is between [1, 10].
      attr_accessor :face_ids

      # @return [String] PersonGroupId of the target person group, created by
      # PersonGroup - Create. Parameter personGroupId and largePersonGroupId
      # should not be provided at the same time.
      attr_accessor :person_group_id

      # @return [String] LargePersonGroupId of the target large person group,
      # created by LargePersonGroup - Create. Parameter personGroupId and
      # largePersonGroupId should not be provided at the same time.
      attr_accessor :large_person_group_id

      # @return [Integer] The range of maxNumOfCandidatesReturned is between 1
      # and 5 (default is 1). Default value: 1 .
      attr_accessor :max_num_of_candidates_returned

      # @return [Float] Confidence threshold of identification, used to judge
      # whether one face belong to one person. The range of confidenceThreshold
      # is [0, 1] (default specified by algorithm).
      attr_accessor :confidence_threshold


      #
      # Mapper for IdentifyRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'IdentifyRequest',
          type: {
            name: 'Composite',
            class_name: 'IdentifyRequest',
            model_properties: {
              face_ids: {
                client_side_validation: true,
                required: true,
                serialized_name: 'faceIds',
                constraints: {
                  MaxItems: 10
                },
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UuidElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              person_group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'personGroupId',
                constraints: {
                  MaxLength: 64,
                  Pattern: '^[a-z0-9-_]+$'
                },
                type: {
                  name: 'String'
                }
              },
              large_person_group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'largePersonGroupId',
                constraints: {
                  MaxLength: 64,
                  Pattern: '^[a-z0-9-_]+$'
                },
                type: {
                  name: 'String'
                }
              },
              max_num_of_candidates_returned: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxNumOfCandidatesReturned',
                default_value: 1,
                constraints: {
                  InclusiveMaximum: 5,
                  InclusiveMinimum: 1
                },
                type: {
                  name: 'Number'
                }
              },
              confidence_threshold: {
                client_side_validation: true,
                required: false,
                serialized_name: 'confidenceThreshold',
                type: {
                  name: 'Double'
                }
              }
            }
          }
        }
      end
    end
  end
end
