# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::Face::V1_0
  module Models
    #
    # Request body for taking snapshot operation.
    #
    class TakeSnapshotRequest

      include MsRestAzure

      # @return [SnapshotObjectType] User specified type for the source object
      # to take snapshot from. Currently FaceList, PersonGroup, LargeFaceList
      # and LargePersonGroup are supported. Possible values include:
      # 'FaceList', 'LargeFaceList', 'LargePersonGroup', 'PersonGroup'
      attr_accessor :type

      # @return [String] User specified source object id to take snapshot from.
      attr_accessor :object_id

      # @return User specified array of target Face subscription ids for the
      # snapshot. For each snapshot, only subscriptions included in the
      # applyScope of Snapshot - Take can apply it.
      attr_accessor :apply_scope

      # @return [String] User specified data about the snapshot for any
      # purpose. Length should not exceed 16KB.
      attr_accessor :user_data


      #
      # Mapper for TakeSnapshotRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TakeSnapshotRequest',
          type: {
            name: 'Composite',
            class_name: 'TakeSnapshotRequest',
            model_properties: {
              type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'type',
                type: {
                  name: 'Enum',
                  module: 'SnapshotObjectType'
                }
              },
              object_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'objectId',
                constraints: {
                  MaxLength: 64,
                  Pattern: '^[a-z0-9-_]+$'
                },
                type: {
                  name: 'String'
                }
              },
              apply_scope: {
                client_side_validation: true,
                required: true,
                serialized_name: 'applyScope',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UuidElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              user_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'userData',
                constraints: {
                  MaxLength: 16384
                },
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
